/************************************************************************/
/*									*/
/* CAMASM macro assembler V1.0		KEK online group   M. Nomachi	*/
/*						3-NOV-1987		*/
/*									*/
/*									*/
/* 8-OCT-1991	modified by Y.Takeuchi (TIT)				*/
/*	o change file extensions .ASM .OBJ .LIS -> .asm .obj .lis	*/
/*	o add  "return 0;" statement  at last of main()			*/
/*									*/
/************************************************************************/

#define camasm_VAX 0

#include "err_code.h"
#include "asm_code.h"
#include <stdio.h>
#include <math.h>
#include <ctype.h>

#define  forever      while(1)

#define C_m_level	10	/* maximum macro nesting */
#define C_f_level	5	/* maximum use file nesting */
#define C_s_level	15	/* maximum substitution nesting */

#define  C_equ      1
#define  C_macro    2
#define  C_location 3

#define C_stable_size	30000	/* substitution table size */

struct code_array {
	int		location;
	int		size;
	unsigned short	code[4];
} code;

struct sptr_array {
	int	level;		/* nesting level */
	char	*ptr[C_s_level];	/* pointer array */
	char	*start;
	int	line_count;
} source;

struct fid_array {
	int	level;			/* nesting level */
	FILE	*id[C_f_level];		/* file id 	 */
	char	name[C_f_level][20];	/* file name (20 character) */
} file;

struct {
	char	name[32];	/* label name */
	int	id;		/* id (location, equ, macro) */
	int	location;	/* location value */
	int	program;		/* program number */
	char	*source;	/* pointer to substitutional strings */
}
	ltable[100];		/* label table (up to 100 label) */
int	nlabel;			/* number of labels */
int	prog_id;		/* current program id */

struct mac_array {
	int	level;			/* macro nesting level		*/
	char	line[C_m_level][160];	/* macro argument line		*/
	char	*ptr[C_m_level][10];	/* macro argument list pointer	*/
	char	*source[C_m_level];	/* macro source pointer		*/
} macro;



char	title[60];	/* list title */

char	stable[C_stable_size];
			/* substitution strings save area */
char	*stb_top;	/* substitution strings save area top address */

int	m_in;		/* macro input flag */

char	pfname[20];	/* list output file name */
char	ofname[20];	/* object output file name */
FILE	*pfid, *ofid;	/* file id */
int	list_on;	/* list on/off switch */

struct {
	int	pointer;
	int	length;
}	mn_index[50];
int	n_index;

struct arg_value {
	unsigned short	high, low;
};


int	last_location, list_line;
int	pass;

unsigned short	obj_code[2000];		/* object */


main(argc,argv)
    int  argc;
    char *argv[];
{
    int i, id;
    int pass1(), pass2(), mn_init();

    puts ("CAMASM macro assembler V0.1 --- KEK online group ---\n");
    puts ("  Modified by Y.Takeuchi Oct-1991\n");

    if (argc<2 || argc>3)
    {	puts("ERROR argument number is invalid\n"); exit(5); }

    for (i=0;argv[1][i]!='.'&&argv[1][i];++i)
    {	file.name[0][i]=argv[1][i]; }
    file.name[0][i]=0;

    strcpy(pfname,file.name[0]); strcat(pfname,".lis");
    strcpy(ofname,file.name[0]); strcat(ofname,".obj");

    if (argv[1][i]==0) strcat(file.name[0],".asm");
    else strcpy(file.name[0],argv[1]);

/**************************************** 8-OCT-1991 Y.Takeuchi ***
 *   strcpy(pfname,file.name[0]); strcat(pfname,".LIS");
 *   strcpy(ofname,file.name[0]); strcat(ofname,".OBJ");
 *
 *   if (argv[1][i]==0) strcat(file.name[0],".ASM");
 *   else strcpy(file.name[0],argv[1]);
 ******************************************************************/

    list_on = (argc==3); stb_top = &stable[0]; *stb_top = 0;
    nlabel = 0; mn_init();

    pass1();
    pass2();

    return 0;
}


int set_label(label) char *label; {
    strcpy(ltable[nlabel].name,label);
    ltable[nlabel].id = C_location;
    ltable[nlabel].program = prog_id;
    ltable[nlabel].location = code.location; nlabel++;
    return (nlabel-1);
}



/****************************************/
/*		pass 1			*/
/****************************************/

int pass1() {
    int   loop, i, cc;
    char  *ptr, label[32], mnemonic[32], terminater;
    FILE  *id;

    int get_line(), get_asm(), exec_asm(), start_macro();
    int find_inst(), set_label();
    char *get_talken();

    pass = 1;
    file.level = 0; macro.level = 0; code.location=1; prog_id = 0;
    for (i=0;i<5;++i) file.id[i]=0;
    id = fopen(file.name[0],"r");
    if (id==0) {printf("Open error %s\n",file.name[0]); exit(1);}
    file.id[0]=id; m_in=0;
	
    for(loop=0;1;loop++) {
	code.size = 0; cc = get_line();
	if (m_in) {
	    if (cc==-1) { puts("No endm is found\n"); exit(1); }
	    if (*source.ptr[source.level]==';') continue;
	    if (*source.ptr[source.level]=='*') continue;
	    get_talken(label,32,&terminater);
	    get_talken(mnemonic,32,&terminater);
	    if (strcmp(mnemonic,"endm")==0) {m_in=0; *stb_top++=0;continue;}
	    ptr = source.start; while (*ptr!=0) *stb_top++=(*ptr++);
	    if (*--stb_top=='\n') stb_top++; *stb_top++ = 0;
	    continue;
	}
	if (cc==-1) break;
	if (*source.ptr[source.level]==';') continue;
	if (*source.ptr[source.level]=='*') continue;

	get_talken(label,32,&terminater);
	get_talken(mnemonic,32,&terminater);

	cc = get_asm(mnemonic);
	if (cc>10) break; if (cc>0) { cc=exec_asm(label,cc); continue; }
	if (cc!=E_nomnemonic) continue;

	if (label[0]!=0) set_label(label);
	if (mnemonic[0]==0) continue;

	cc = start_macro(mnemonic); if (cc==0) continue;
	cc = find_inst(0,mnemonic,&terminater); if (cc<0) continue;
	code.location += mntable[cc].csize;
    }
    return 0;
}



/****************************************/
/*		pass 2			*/
/****************************************/

int pass2() {
    int     i, cc;
    char    label[32], mnemonic[32], terminater;
    struct  arg_value value[2];
    FILE    *id;

    int get_line(), get_asm(), exec_asm(), start_macro(), find_inst();
    int get_code(), set_label();
    char *get_talken();
    int list_head(), list_out(), obj_out();

    pass = 2; prog_id = 0;
    file.level = 0; macro.level=0; code.location=1; source.line_count = 0;
    for (i=0;i<5;++i) file.id[i]=0;
    id = fopen(file.name[0],"r");
    if (id==0) {printf("Open error %s\n",file.name[0]); exit(1);}
    file.id[0]=id; m_in=0;
    ofid = fopen(ofname,"w"); if (ofid==0) {
	printf("Open error %s\n",ofname); exit(1);
    }
    if (list_on) {
	id = fopen(pfname,"w");
	if (id==0) {printf("Open error %s\n",ofname); exit(1);} pfid=id;
	list_head();
    }
	
    for(;1;list_out(cc)) {
	code.size = 0;
	cc = get_line();
	if (m_in) {
	    if (cc==-1) { puts("No endm is found\n"); exit(1); }
	    if (*source.ptr[source.level]==';') continue;
	    if (*source.ptr[source.level]=='*') continue;
	    get_talken(label,32,&terminater);
	    get_talken(mnemonic,32,&terminater);
	    if (strcmp(mnemonic,"endm")==0) m_in=0;
	    continue;
	}
	if (cc==-1) break;
	if (*source.ptr[source.level]==';') continue;
	if (*source.ptr[source.level]=='*') continue;

	get_talken(label,32,&terminater);
	get_talken(mnemonic,32,&terminater);
	if (mnemonic[0]==0) continue;
	cc = get_asm(mnemonic);
	if (cc>10) break; if (cc != E_nomnemonic) continue;

	cc = start_macro(mnemonic); if (cc==0) continue;
	cc = find_inst(value,mnemonic,&terminater); if (cc<0) continue;
	cc = get_code(cc,value,&code); if (cc<0) continue;

	for (i=0; i<code.size; i++) obj_code[code.location+i] = code.code[i];
	code.location += code.size;
    }
    obj_out(); close(ofid);
    if (list_on) {
	if (file.level>=0) list_out(0);
	close(pfid);
    }
    return 0;
}



/****************************************/
/*		get_asm			*/
/****************************************/

int get_asm(mnemonic) char *mnemonic; {
    char term, *ptr; int i; FILE *id;
    int obj_out();

    char *get_talken();

    /* Mnemonics for assembler operations */
    static char *asm_mnemonic[8] =
	{"end", "equ", "title", "use", "macro", "endm", "program", "\0"};

    for (i=0; strcmp(mnemonic,asm_mnemonic[i])!=0; i++) {
	if (i>=6) return(E_nomnemonic);
    }

    switch(i) {
        case 0:	/* end */
	    if (file.level==0) return(16);
	    close(file.id[file.level]);
	    file.id[file.level]=0; --file.level;
	    break;
	case 3:	/* use */
	    if(file.level>=C_f_level) return(E_toouse);
	    file.level++; ptr = &file.name[file.level][0];
	    ptr = get_talken(ptr,16,&term); --ptr;
	    if (term=='.') {*ptr++=term; get_talken(ptr,4,&term);}
	    else { strcpy(ptr,".ASM"); *ptr++=0;}
	    id = fopen(file.name[file.level],"r");
	    if (id==0) return(E_useopen);
 	    file.id[file.level]=id; break;
	case 5: /* endm */
	    return(E_endm);
	case 6: /* program */
	    if (pass==2) obj_out();
	    prog_id += 1; code.location = 1; break;
	default :
	    return(i);
    }
    return(0);
}



/****************************************/
/*		exec_asm		*/
/****************************************/

int exec_asm(label,i) char *label; int i; {
    char term; int j;

    char *get_talken();

    switch(i) {
        case 1:	/* equ */
	    if (*label==0) return(E_equnam);
	    strcpy(ltable[nlabel].name,label);
	    ltable[nlabel].id=C_equ; ltable[nlabel].source=stb_top;
	    stb_top = get_talken(stb_top,100,&term); nlabel++;
	    break;
	case 2:	/* title */
	    strcpy(title,source.ptr[source.level]);
	    j = strlen(title); if(title[j-1]=='\n') title[j-1]=0;
	    break;
	case 4:	/* macro */
	    if (*label==0) return(E_macnam);
	    strcpy(ltable[nlabel].name,label);
	    ltable[nlabel].id=C_macro; ltable[nlabel].source=stb_top;
	    nlabel++; m_in = 1; break;
    }
    return(0);
}



/****************************************/
/*		obj_out			*/
/****************************************/

int obj_out() {
    int i;

    obj_code[0] = code.location; obj_code[code.location] = 0;
    for (i=0; i < code.location; i++) {
	fprintf(ofid," %04.4X",obj_code[i]); if ((i%4)==0) fprintf(ofid,"\n");
    }
    for (; i%4 != 1; i++) fprintf(ofid," %04.4X",0);
    fprintf(ofid,"\n"); return 0;
}



/****************************************/
/*		get_code		*/
/****************************************/

int get_code(ptr,value,c)
    int ptr; struct arg_value *value; struct code_array *c; {
    int i,k;

    c->size = mntable[ptr].csize;
    c->code[0] = (mntable[ptr].code[0]);
    if (mntable[ptr].code[1]==O_siz) { 
	c->code[0] |= ((c->size)<<8);
    }
    else if (mntable[ptr].otype[0]==mntable[ptr].code[1] ) {
	c->code[0] |= ((value->low)<<8);
    }
    else if (mntable[ptr].otype[1]==mntable[ptr].code[1] ) {
	c->code[0] |= (((value+1)->low)<<8);
    }
    for (i=1;i<c->size;i++) {
	k = (mntable[ptr].code[i+1] & 0x1F );
	if (mntable[ptr].otype[0]==k) {
	    if((mntable[ptr].code[i+1] & O_high)!=0) c->code[i] = value->high;
	    else c->code[i] = value->low;
	}
	else if (mntable[ptr].otype[1]==k) {
	    if((mntable[ptr].code[i+1] & O_high)!=0) {
		c->code[i] = (value+1)->high;
	    }
	    else c->code[i] = (value+1)->low;
	}
	else return(E_mntable);
    }
    return(0);
}


/****************************************/
/*		mn_init			*/
/****************************************/

int mn_init() {
    int i_index,i_table,last,i;
    i_index=last=0;

    for(i_table=0;mntable[i_table].csize>0;i_table++) {
	if (last==0)  { mn_index[i_index].pointer = i_table;
			mn_index[i_index].length = mntable[i_table].csize;
			i_index++; }
	else if (mn_index[i_index-1].length!=mntable[i_table].csize) {
			mn_index[i_index-1].length=0; }
	last = mntable[i_table].cont;
    }
/*    for(i=0;i<i_index;i++) {
	printf(" %d %s %d %d\n",
	i,mntable[mn_index[i].pointer].name,
	mn_index[i].pointer,mn_index[i].length);
    }
*/
    mn_index[i_index].pointer=-1; return 0;
}
    



/****************************************/
/*		list_head		*/
/****************************************/

int list_head() {
    fprintf(pfid," CAMASM macro assembler %s \n\n",title);
    last_location = code.location; list_line = 0;
    return 0;
}



/****************************************/
/*		list_out		*/
/****************************************/

int list_out(cc) int cc; {

    int i, j; char string[132], term; char *ptr;

    if (list_on) {
	if (m_in) fprintf(pfid," M0 %3X:",last_location);
	else if (macro.level) {
	    fprintf(pfid," M%1d %3X:",macro.level,last_location);
	}
	else fprintf(pfid," F%1d %3X:",file.level,last_location);

	for (i=0;i<4;i++) {
	    if (i<code.size) fprintf(pfid," %04.4X",code.code[i]);
	    else fprintf(pfid,"     ");
	}
	fprintf(pfid,"\t%s",source.start);
	if (code.size>4) {
	    fprintf(pfid,"       :");
	    for (i=4;i<8;i++) {
		if (i<code.size) fprintf(pfid," %04.4X",code.code[i]);
		else fprintf(pfid,"     ");
	    }
	}
	list_line +=1; if (list_line == 60) list_head();
    }

    last_location = code.location;
    if (cc>=0) return 0;

    for (i=0, ptr=source.start; *ptr!=0 && ptr!=source.ptr[0]; ptr++,i++) {
	if(*ptr=='\t') string[i]='\t';
	else string[i]=' ';
    }
    string[i-1] = '^'; string[i] = 0;
	
    printf("%s",source.start);
    printf("%s\n",string);
    if (list_on) fprintf(pfid,"\t\t\t\t%s\n",string);

    if ((cc-(E_uxop))<0) { 
	if (list_on) fprintf(pfid," Error -- %4d %s\n",
				   -(E_uxop),"unexpected operald is found");
	printf(" Error -- %4d %s\n",-(E_uxop),"unexpected operald is found");
	cc -= E_uxop;
    }
    for (i=0;err_table[i].code!=0;i++) if(cc==err_table[i].code) break;
    if (list_on) fprintf(pfid," Error -- %4d %s\n",-cc,err_table[i].message);
    printf(" Error -- %4d %s\n",-cc,err_table[i].message);

}



/****************************************/
/*		find_label		*/
/****************************************/

int find_label(name,ref) char *name; int ref; {
    int i;
    if (ref==0) {
	for (i=0;i<nlabel;i++) {
	    if(strcmp(ltable[i].name,name)==0) {
		if (ltable[i].id!=C_location) return(i);
		else if (ltable[i].program==prog_id) return(i);
	    }
	}
    }
    else if (ref!=C_location) {
	for (i=0;i<nlabel;i++) {
	    if (ltable[i].id!=ref) continue;
	    if (strcmp(ltable[i].name,name)==0) return(i);
	}
    }
    else {
	for (i=0;i<nlabel;i++) {
	    if(ltable[i].id!=C_location || ltable[i].program!=prog_id) continue;
	    if(strcmp(ltable[i].name,name)==0) return(i);
	}
    }
    return(E_nolabel);
}


/****************************************/
/*		start_macro		*/
/****************************************/

int start_macro(mnemonic) char *mnemonic; {
    char *ptr, term; int cc, j;

    char *get_talken();

    cc = find_label(mnemonic,C_macro); if (cc<0) return(cc);
    macro.level++; ptr = &macro.line[macro.level][0];
    macro.source[macro.level] = ltable[cc].source;
    for (j=0;j<10;j++) {
	macro.ptr[macro.level][j]=ptr;	ptr = get_talken(ptr,100,&term);
    }
    return(0);
}




/****************************************/
/*		get_fna			*/
/****************************************/

int get_fna(x,F,N,A) struct arg_value *x; long F,N,A; {
    if (F>31 || F<0) return(E_fvalue);
    if (N>31 || N<0) return(E_nvalue);
    if (A>15 || A<0) return(E_avalue);
#ifdef camasm_VAX
    x->low = (N<<9) | (A<<5) | F ;
#endif
#ifdef camasm_PC98
    x->low   = (A<<8) | N;
#endif
    x->high  = F;
    return(0);
}



/****************************************/
/*		find_inst		*/
/****************************************/

int find_inst(value,mnemonic,term)
    char *term, *mnemonic; struct arg_value *value; {
    char string[32];
    int dsize, otype[2], i, k, cc, ptr;
    struct arg_value x[2];

    int get_op();

    char *get_talken();

    for (i=0;1;i++) {
	if ( (ptr = mn_index[i].pointer) < 0) return(E_nomnemonic);
	if ( strcmp(mntable[ptr].name,mnemonic)==0) break;
    }
    if (value==0) {
	if (mn_index[i].length>0) return(ptr) ;
	else value = &x[0];
    }

    if (*term=='.') {			/* check data size */
	get_talken(string,32,term);
	if (string[0]=='l') dsize=D_dl;
	else if (string[0]=='w') dsize=D_dw;
	else return(E_dsize);
    }
    else dsize=D_nd;
    while ((mntable[ptr].dsize&dsize)==0) {
	if (mntable[ptr].cont==0) return(E_uxdsize); ptr++;
    }

    cc=get_op(&otype[0],value,term);
    if(cc<0) {			/* with no operand */
	while (mntable[ptr].osize!=0 || (mntable[ptr].dsize&dsize)==0 ) {
	    if (mntable[ptr].cont==0) return(cc); ptr++;
	}
    }
    else {
        cc=get_op(&otype[1],value+1,term);
	if (cc<0) {		/* with one operand */
	    while (mntable[ptr].osize!=1 || (mntable[ptr].dsize&dsize)==0
		|| mntable[ptr].otype[0]!=otype[0]) {
		    if (mntable[ptr].cont==0) return(cc+E_uxop); ptr++;
	    }
	}
	else {
	    while (mntable[ptr].osize!=2 || (mntable[ptr].dsize&dsize)==0
		|| mntable[ptr].otype[0]!=otype[0]
		|| mntable[ptr].otype[1]!=otype[1]) {
		    if (mntable[ptr].cont==0) return(E_uxop); ptr++;
	    }
	}
    }
    return(ptr);
}



/****************************************/
/*		get_op			*/
/****************************************/

int get_op(type,x,term)
    int *type; struct arg_value *x; char *term; {

    char string[32], temp_term[2]; int cc; long value,F,N,A;
    char *get_talken(); int find_label(), get_value();

    *type = 0; x->low = 0; x->high = 0;
    get_talken(string,32,term);
    if (string[0]!=0) {
	if (strcmp(string,"A")==0)		{*type=O_A;   return(0);}
	else if (strcmp(string,"S")==0)		{*type=O_S;   return(0);}
	else if (strcmp(string,"T")==0)		{*type=O_T;   return(0);}
	else if (strcmp(string,"PTR")==0)	{*type=O_PTR; return(0);}
	else if (strcmp(string,"REMAINDER")==0)	{*type=O_REM; return(0);}
	else if (strcmp(string,"TIMER")==0)	{*type=O_TIM; return(0);}
	else if (strcmp(string,"COUNT")==0)	{*type=O_CNT; return(0);}
	else if (strcmp(string,"CAMACSTATUS")==0) {*type=O_CAM; return(0);}

	if (strcmp(string,"HEADER")==0) {
	    if (*term!='(')			 return(E_nobra);
	    cc = get_value(&value,term); if(cc<0) return(cc);
	    if (*term!=')')			 return(E_noket);
	    get_talken(string,32,term);
	    if (string[0]!=0)			 return(E_ket);
	    *type = O_head; x->low = value; return(0);
	}

	cc = find_label(string,0);
	if (cc>=0) {
	    if (ltable[cc].id==C_location) {
		x->low = ltable[cc].location; *type=O_labl; return(0);
	    }
	    else if (ltable[cc].id==C_equ) {
		source.level++; source.ptr[source.level] = &temp_term[0];
		temp_term[0] = *term; temp_term[1]=0;
		source.level++; source.ptr[source.level]=ltable[cc].source;
		return (get_op(type,x,term));
	    }
	    else return(E_uxmac);
	}

	source.level++; source.ptr[source.level] = &temp_term[0];
	temp_term[0] = *term; temp_term[1]=0;
	source.level++; source.ptr[source.level] = &string[0];
	cc = get_value(&value,term); if (cc<0) return(cc);
	x->low  = (unsigned short) (value & 0xFFFF);
	x->high = (unsigned short) ((value>>16) & 0xFFFF);
	*type=O_num; return(0);
    }
    else {
	if (*term=='#') {
	    cc = get_value(&value,term); if (cc<0) return(cc);
	    x->low  = (unsigned short) (value & 0xFFFF);
	    x->high = (unsigned short) ((value>>16) & 0xFFFF);
	    *type=O_dat; return(0);
	}
	else if (*term=='(') {
			/* ?????  (PTR)+  ????? */
	    if (strncmp(source.ptr[source.level],"PTR)+",5)==0) {
		source.ptr[source.level] += 4; get_talken(string,32,term);
		*type=O_buff; return(0);
	    }
			/* ????? (equation) ????? */
	    cc = get_value(&value,term); if (cc<0) return(cc);
	    if (*term==')') {
		get_talken(string,32,term); if (string[0]!=0) return(E_ket);
		x->low  = (unsigned short) (value & 0xFFFF);
		x->high = (unsigned short) ((value>>16) & 0xFFFF);
		*type=O_num; return(0);
	    }
			/* ????? (F,N,A) ????? */
	    if (*term!=',') return(E_fna);
	    F = value;
	    cc = get_value(&N,term);
	    if(cc<0) return(cc); if(*term!=',') return(E_fna);
	    cc = get_value(&A,term);
	    if(cc<0) return(cc); if(*term!=')') return(E_fna);
	    get_talken(string,32,term); if (string[0]!=0) return(-1);
	    cc = get_fna(x,F,N,A); if (cc<0) return(cc);
	    *type=O_fna; return(0);
	}
	return(E_invop);
    }
}



/****************************************/
/*		get_value		*/
/****************************************/

int get_value(value,term) long *value; char *term; {

    long x; char operation; int cc;
    int get_term();

    *value = 0;
    if (*source.ptr[source.level]=='-') {
	operation = *source.ptr[source.level]++;
    }
    else if (*source.ptr[source.level]=='+') {
	operation = *source.ptr[source.level]++;
    }
    else operation = '+';
    forever {
	cc = get_term(&x,term);
	if (cc<0) return (cc);
	if (operation == '+') *value += x;
	if (operation == '-') *value -= x;
	operation = *term;
	if (operation != '+' && operation != '-') return(0);
    }
}
    


/****************************************/
/*		get_term		*/
/****************************************/

int get_term(value,term)
    long *value; char *term; {

    long x; char operation; int cc;
    int get_factor();

    cc = get_factor(value,term);
    if (cc<0) return (cc);
    if (*term=='*') operation = *term;
    else if (*term=='/') operation = *term;
    else return(0);
    
    forever {
	cc = get_factor(&x,term);
	if (cc<0) return (cc);
	if (operation == '*') *value *= x;
	if (operation == '/') *value /= x;
	operation = *term;
	if (operation != '*' && operation != '/') return(0);
    }
}
    



/****************************************/
/*		get_factor		*/
/****************************************/

int get_factor(value,term)
    long *value; char *term; {
    int cc; char name[32], temp_term[2], *ptr;
    char *get_talken(); int find_label(); long strtol();

    get_talken(name,32,term);
    if (name[0]==0) {
	if (*term!='(') return(E_nofact);
	cc = get_value(value,term);
	if (cc < 0 ) return(cc);
	if (*term!=')') return(E_noket);
	get_talken(name,32,term);
	if (name[0]!=0) return(E_ket); return (0);
    }

    cc = find_label(name,C_equ);
    if (cc>=0) {
	source.level++; source.ptr[source.level] = &temp_term[0];
	temp_term[0] = *term; temp_term[1]=0;
	source.level++; source.ptr[source.level]=ltable[cc].source;
	cc = get_factor(value,term);
	return(cc);
    }

    ptr = &name[0]; *value = strtol(name,&ptr,0); if(*ptr!=0) return(E_invnum);
    return(0);
}



/****************************************/
/*		get_line		*/
/****************************************/

int get_line() {
    static char sline[160]; char *ptr;

    source.level=0;
    while(macro.level!=0) {
	if(*macro.source[macro.level]!=0) {
	    source.ptr[source.level]=macro.source[macro.level];
	    source.start = source.ptr[source.level];
	    while(*macro.source[macro.level]!=0) {
		macro.source[macro.level]++;
	    }
	    macro.source[macro.level]++; return(0);
	}
	else --macro.level;
    }
    do {
	ptr = fgets(sline,150,file.id[file.level]);
	if (ptr!=0) {
	    source.ptr[source.level] = &sline[0]; source.line_count++;
	    source.start = source.ptr[source.level];
	    return(0);
	}
	else close(file.id[file.level]); file.id[file.level]=0; --file.level;
    } while(file.level>=0);
    return(-1);
}


/****************************************/
/*		get_talken		*/
/****************************************/

char *get_talken(name,limit,term) char *name, *term; int limit; {
    int i;          /* # of character in this talken */
    int j;          /* replace id                    */
    char arg[32];   /* temporary argument name area  */
    int isname(), iseol();

    for(i=0;1;) {
	if (isname(*source.ptr[source.level])) {
	    if(i<limit) {*name++=(*source.ptr[source.level]++);i++;}
	    else source.ptr[source.level]++;
	}
	else if (*source.ptr[source.level]=='"') {
	    source.ptr[source.level]++;
	    while(*source.ptr[source.level]!='"' 
			&& !iseol(*source.ptr[source.level])) {
		if(i<limit) {*name++=(*source.ptr[source.level]++);i++;}
		else source.ptr[source.level]++;
	    }
	    if (*source.ptr[source.level]=='"') source.ptr[source.level]++;
	}
	else if (iseol(*source.ptr[source.level])) {
	    if (source.level==0) {*term=0; break;}
	    else --source.level;
	}
	else if (*source.ptr[source.level]=='\\') {
	    source.ptr[source.level]++;
	    if (isdigit(*source.ptr[source.level])) {
		arg[0]=(*source.ptr[source.level]++), arg[1]=0; j = atoi(arg)-1;
		if (*source.ptr[source.level]=='\\') source.ptr[source.level]++;
		source.level++;
		source.ptr[source.level] = macro.ptr[macro.level][j];
	    }
	    else {
		for (j=0;isname(*source.ptr[source.level]);
					source.ptr[source.level]++) {
		    if (j<32) {arg[j]=(*source.ptr[source.level]);j++;}
		}
		arg[j]=0;
		if (*source.ptr[source.level]=='\\') source.ptr[source.level]++;
		j=find_label(arg,C_equ); if(j==-1) continue;
		source.level++; source.ptr[source.level]=ltable[j].source;
	    }
	}
	else {
	    *term = (*source.ptr[source.level]++);
	    while(*source.ptr[source.level]==' ' 
		|| *source.ptr[source.level]=='\t') source.ptr[source.level]++;
	    break;
	}
    }
    *name++ = 0; return(name);
}
		


/****************************************/
/*	   iseol	isname		*/
/****************************************/

int iseol(c) char c; { return( (c=='\0') || (c=='\n') || (c==';') ); }

int isname(c) char c; { return( isalnum(c) || (c=='_') || (c=='$') ); }

/****************************************/
/*		strtol			*/
/****************************************/

long strtol(str,ptr,base) char *str, **ptr; int base; {

    long v;

    if (*str=='0') { str++; 
	if (*str=='x' || *str=='X') {		/* 16 */
	    for( str++, v=0; *str!=0; str++) {
		v <<= 4;
		if (isdigit(*str)) v += (*str&0xF);
		else if (isxdigit(*str)) v += (*str&0xF) + 9;
		else break;
	    }
	    *ptr = str; return(v);
	}
	else {					/* 8 */
	    for(v=0;*str!=0;str++) {
		v <<= 3;
		if (isdigit(*str) && ((*str&0xF)<8)) v += (*str&0xF);
		else break;
	    }
	    *ptr = str; return(v);
	}
    }						/* 10 */

    for(v=atol(str);*str!=0;str++) if(!isdigit(*str)) break;
    *ptr = str; return(v);
}

