********************************************************************
* camh2.f        8-OCT-1991             Y.Takeuchi                 *
*                                                                  *
* CAMAC and HBOOK example program                                  *
* measure CAMAC block action speed                                 *
* SPARC  SFVME-100  K2917  K3922                                   *
********************************************************************
      integer i, loop, nprint, icycle
      real dummy, hmemor
      integer nn, nnt, nq, nx, ndat(100000), ndat1
      integer*2 ndats(100000)
      integer naf, nafw, nafr, nafc, naft
      integer mode, minlen, maxlen, len, lenr, nerr

      common /pawc/ hmemor(1000000)
c
c Parameters
c

c Block Transfer mode (0,1,2,3)
      mode = 1

c Scaler
      nnt  = 6

c Switch Register
      nn   = 11

      nafr = NAF(nn,  1, 0)
      nafw = NAF(nn,  0, 16)
      nafc = NAF(nnt, 0, 9)
      naft = NAF(nnt, 0, 0)

      write(0, 4)
      read(*,*) minlen
      write(0, 5)
      read(*,*) maxlen
      write(0, 10)
      read(*,*) loop
      write(0, 20)
      read(*,*) nprint
c
c Initialize hbook
c
      call hlimit(1000000)
      call hbook1( 2, 'CAMACW  T=0  (micro sec)$', 200, 0., 1000., 0.)
      call hbook2(11, 'CDMAW Read   (micro sec)$',
     $     200, float(minlen), float(maxlen), 200, 0., 20000., 0.)
      call hbook2(12, 'CDMAW Write  (micro sec)$',
     $     200, float(minlen), float(maxlen), 200, 0., 20000., 0.)
      call hbook2(21, 'CDMAL Read   (micro sec)$',
     $     200, float(minlen), float(maxlen), 200, 0., 20000., 0.)
      call hbook2(22, 'CDMAL Write  (micro sec)$',
     $     200, float(minlen), float(maxlen), 200, 0., 20000., 0.)
c
c Initialize CAMAC
c
      call CAMOPN()
      call CGENZ()
      call CGENC()
      call CREMI()
c
c Measurement
c
      do 100 i = 1, loop
         do 200 len = minlen, maxlen
            call CAMACW(nafc, ndat1, nq, nx)
            call CAMACW(naft, ndat1, nq, nx)
            call hfill( 2, float(ndat1), dummy, 1.)
            call CAMACW(nafc, ndat1, nq, nx)
            call CDMAW(mode, nafr, ndats, len, lenr, nerr)
            call CAMACW(naft, ndat1, nq, nx)
            if (nerr .ne. 0) write(0,*) 'ERROR!'
            call hfill(11, float(len), float(ndat1), 1.)
            call CAMACW(nafc, ndat1, nq, nx)
            call CDMAW(mode, nafw, ndats, len, lenr, nerr)
            call CAMACW(naft, ndat1, nq, nx)
            if (nerr .ne. 0) write(0,*) 'ERROR!!'
            call hfill(12, float(len), float(ndat1), 1.)
            call CAMACW(nafc, ndat1, nq, nx)
            call CDMAL(mode, nafr, ndat, len, lenr, nerr)
            call CAMACW(naft, ndat1, nq, nx)
            if (nerr .ne. 0) write(0,*) 'ERROR!!!'
            call hfill(21, float(len), float(ndat1), 1.)
            call CAMACW(nafc, ndat1, nq, nx)
            call CDMAL(mode, nafw, ndat, len, lenr, nerr)
            call CAMACW(naft, ndat1, nq, nx)
            if (nerr .ne. 0) write(0,*) 'ERROR!!!!'
            call hfill(22, float(len), float(ndat1), 1.)
 200     continue
 100  continue
c
c Write data to file
c
      open(unit=10,file='camh2.hdat',form='unformatted',recl=4096,
     $     access='direct',status='unknown')
      call hrfile(10, 'camh2', 'N')
      call hrout(0, icycle, ' ')
      call hrend('camh2')
      close(10)
c
c Display
c
      if (nprint .eq. 1) then
         call histdo
      endif
      call hplint(1)
      print *, ' Push return'
      read(*,*)
      call hplopt('PTO ', 1)
      call hplopt('HARD', 1)
      call hplzon(1, 1, 0, ' ')
      call hplot(0, ' ', ' ', 0)
      call hplend
c
c End
c
      call CAMCLS()
      stop
 4    format(' ', 'Input minlen  >', $)
 5    format(' ', 'Input maxlen  >', $)
 10   format(' ', 'Input loop    >', $)
 20   format(' ', 'Print? (1:yes 0:no) >', $)
      end
