/************************************************************************
 *	camt4.c       	  2-DEC-1991		Y.Takeuchi (TIT)	*
 *									*
 *	CAMAC list speed test						*
 *	CAMAC Scaler ch1: input 1MHz pulse				*
 *	camt4 [loop_count [list_file_name1 [list_file_name2 ... ]]]	*
 ************************************************************************/
#include <stdio.h>
#include "camtest.h"
#include "camlib.h"

#define DEFLOP    10
#define DEFNAME1  "camt41.obj"
#define DEFNAME2  "camt42.obj"
#define DEFNAME3  "camt43.obj"
#define DEFNAME9  "camt49.obj"
#define MAXLOOP   100000
#define MAXLIST   2000

main(argc, argv)
int argc;
char *argv[];
{
    int nafct, nafrt, q, x, dumy, dat0, dat1;
    int i, j, loop;
    int lenlis, data[MAXLOOP];
    unsigned short list[MAXLIST], *datas;
    struct cc_iosb iosb;
    char filename[10][33];

/* Read options */
    loop = (argc > 1) ? atoi(argv[1]) : DEFLOP;
    strcpy(filename[0], (argc > 2) ? argv[2] : DEFNAME1);
    strcpy(filename[1], (argc > 3) ? argv[3] : DEFNAME2);
    strcpy(filename[2], (argc > 4) ? argv[4] : DEFNAME3);
    strcpy(filename[9], (argc > 5) ? argv[5] : DEFNAME9);

/* Initialize valiable */
    nafct = NAF(CAMAC_SCALER, 1, 9);
    nafrt = NAF(CAMAC_SCALER, 1, 0);
    iosb.s_reg = loop;

/* Open and Initialize CAMAC */
    if (CAMOPN()) {
      perror("CAMOPN");
      exit(1);
  }
    CSETCR(0);
    CGENC();
    CGENZ();
    CREMI();

/**** Measurement ****/
/* 24bit time=0 */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++) {
	CAMAC(nafct, &dumy, &q, &x);
	CAMAC(nafrt, &dat0, &q, &x);
	CAMAC(nafrt, &dat1, &q, &x);
	printf("%d\n", dat1 - dat0);
    }

    for (j = 0; j < 3; j++) {
	/* Read and Install CAMAC list */
	if (CRLIST(filename[j], list, MAXLIST, &lenlis, &i)) {
	    perror("CRLIST");
	    exit(2);
	}
	if (CLLOAD(list, lenlis, &i)) {
	    perror("CLLOAD");
	    exit(3);
	}

	/* Execute list */
	printf("%d\n", loop);
	for (i = 0; i < loop; i++) {
	    CAMAC(nafct, &dumy, &q, &x);
	    CAMAC(nafrt, &dat0, &q, &x);
	    if (CEWAI(data, MAXLOOP, &iosb)) {
		perror("CEWAI");
		exit(10);
	    }
	    CAMAC(nafrt, &dat1, &q, &x);
	    printf("%d\n", dat1 - dat0);
	}
    }

/* Read and Install CAMAC list 9 */
    if (CRLIST(filename[9], list, MAXLIST, &lenlis, &i)) {
	perror("CRLIST");
        exit(2);
    }
    if (CLLOAD(list, lenlis, &i)) {
	perror("CLLOAD");
        exit(3);
    }

/* Execute list 9 */
    if (CEWAI(data, MAXLOOP, &iosb)) {
	perror("CEWAI");
	exit(10);
    }

/* 24bit time=0 */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", data[(i*2)+1] - data[i*2]);

/* MOVE */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", data[loop*2+(i*2)+1] - data[loop*2+i*2]);

/* MUL */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", data[loop*4+(i*2)+1] - data[loop*4+i*2]);


/* SUB */
    printf("%d\n", loop);
    for (i = 0; i < loop; i++)
	printf("%d\n", data[loop*6+(i*2)+1] - data[loop*6+i*2]);

/* End */
    CAM_Close();
}



