/************************************************************************
 * sreg1.c                23-MAR-1992             Y.Takeuchi            *
 *                                                                      *
 * cc -O -o sreg sreg.c                                                 *
 * Show SFVME registers                                                 *
 *                                                                      *
 * 17-SEP-1992 suport SFVME-116         modified by Y.Takeuchi          *
 ************************************************************************/
#include <stdio.h>
#include <sys/file.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sbusdev/sfvmereg.h>
#include <sbusdev/sfvmevar.h>
#include "sfvme_config.h"

#ifdef SFVME-116
#define ADDRESS_OFFSET    0x3FF000
#else
#define ADDRESS_OFFSET    0x7FF000
#endif

#define SIZE              0x100

main()
{
    char    *open_arg = SBUS_SLOT;
    int     page_size;
    off_t   page_start;
    int     page_offset;
    caddr_t page_addr;
    int     fd;
    int i;
    vme_interface_t *v;

    if ((fd = open(open_arg, O_RDWR)) < 0) {
	printf("Open error %s \n", open_arg);
	exit(1);
    }

    page_size   = getpagesize();
    page_start  = (ADDRESS_OFFSET / page_size) * page_size;
    page_offset = (ADDRESS_OFFSET % page_size);

    page_addr = mmap((caddr_t)0, SIZE + page_offset, PROT_READ | PROT_WRITE,
		     MAP_SHARED, fd, page_start);

    if (page_addr == (caddr_t)-1) {
	printf("Map error!\n");
	exit(2);
    }

    v = (vme_interface_t *)page_addr;

    printf("\n");
    printf("    BLOCK :%02x\n", v->vme_locker);
/*
    printf("    IACK1 :%2x\n", v->vme_iack1);
*/
    printf("    SREG  :%02x\n", v->vme_slavemap);
    printf("    VMAP1 :%02x\n", v->vme_a24map);
    printf("    VMAP2 :%04x\n", v->vme_a32map & ~0x7f);
    printf("    IREG  :%02x\n", v->vme_interrupt); 
    printf("\n");

    close(fd);
}
